package javax.xml.stream;

import javax.xml.stream.util.XMLEventAllocator;
import java.io.InputStream;
import javax.xml.transform.Source;
import java.io.Reader;

public abstract class XMLInputFactory
{
    public static final String IS_NAMESPACE_AWARE = "javax.xml.stream.isNamespaceAware";
    public static final String IS_VALIDATING = "javax.xml.stream.isValidating";
    public static final String IS_COALESCING = "javax.xml.stream.isCoalescing";
    public static final String IS_REPLACING_ENTITY_REFERENCES = "javax.xml.stream.isReplacingEntityReferences";
    public static final String IS_SUPPORTING_EXTERNAL_ENTITIES = "javax.xml.stream.isSupportingExternalEntities";
    public static final String SUPPORT_DTD = "javax.xml.stream.supportDTD";
    public static final String REPORTER = "javax.xml.stream.reporter";
    public static final String RESOLVER = "javax.xml.stream.resolver";
    public static final String ALLOCATOR = "javax.xml.stream.allocator";
    static final String DEFAULIMPL = "com.sun.xml.internal.stream.XMLInputFactoryImpl";
    
    protected XMLInputFactory() {
    }
    
    public static XMLInputFactory newInstance() throws FactoryConfigurationError {
        return (XMLInputFactory)FactoryFinder.find(XMLInputFactory.class, "com.sun.xml.internal.stream.XMLInputFactoryImpl");
    }
    
    public static XMLInputFactory newFactory() throws FactoryConfigurationError {
        return (XMLInputFactory)FactoryFinder.find(XMLInputFactory.class, "com.sun.xml.internal.stream.XMLInputFactoryImpl");
    }
    
    @Deprecated
    public static XMLInputFactory newInstance(String factoryId, ClassLoader classLoader) throws FactoryConfigurationError {
        return (XMLInputFactory)FactoryFinder.find(XMLInputFactory.class, factoryId, classLoader, null);
    }
    
    public static XMLInputFactory newFactory(String factoryId, ClassLoader classLoader) throws FactoryConfigurationError {
        return (XMLInputFactory)FactoryFinder.find(XMLInputFactory.class, factoryId, classLoader, null);
    }
    
    public abstract XMLStreamReader createXMLStreamReader(Reader p0) throws XMLStreamException;
    
    public abstract XMLStreamReader createXMLStreamReader(Source p0) throws XMLStreamException;
    
    public abstract XMLStreamReader createXMLStreamReader(InputStream p0) throws XMLStreamException;
    
    public abstract XMLStreamReader createXMLStreamReader(InputStream p0, String p1) throws XMLStreamException;
    
    public abstract XMLStreamReader createXMLStreamReader(String p0, InputStream p1) throws XMLStreamException;
    
    public abstract XMLStreamReader createXMLStreamReader(String p0, Reader p1) throws XMLStreamException;
    
    public abstract XMLEventReader createXMLEventReader(Reader p0) throws XMLStreamException;
    
    public abstract XMLEventReader createXMLEventReader(String p0, Reader p1) throws XMLStreamException;
    
    public abstract XMLEventReader createXMLEventReader(XMLStreamReader p0) throws XMLStreamException;
    
    public abstract XMLEventReader createXMLEventReader(Source p0) throws XMLStreamException;
    
    public abstract XMLEventReader createXMLEventReader(InputStream p0) throws XMLStreamException;
    
    public abstract XMLEventReader createXMLEventReader(InputStream p0, String p1) throws XMLStreamException;
    
    public abstract XMLEventReader createXMLEventReader(String p0, InputStream p1) throws XMLStreamException;
    
    public abstract XMLStreamReader createFilteredReader(XMLStreamReader p0, StreamFilter p1) throws XMLStreamException;
    
    public abstract XMLEventReader createFilteredReader(XMLEventReader p0, EventFilter p1) throws XMLStreamException;
    
    public abstract XMLResolver getXMLResolver();
    
    public abstract void setXMLResolver(XMLResolver p0);
    
    public abstract XMLReporter getXMLReporter();
    
    public abstract void setXMLReporter(XMLReporter p0);
    
    public abstract void setProperty(String p0, Object p1) throws IllegalArgumentException;
    
    public abstract Object getProperty(String p0) throws IllegalArgumentException;
    
    public abstract boolean isPropertySupported(String p0);
    
    public abstract void setEventAllocator(XMLEventAllocator p0);
    
    public abstract XMLEventAllocator getEventAllocator();
}
